
;#include "${LavishScript.HomeDirectory}/Scripts/EQ2OgreCommon/OgreMapController.inc"
;#include EQ2OgreCommon/OgreNav_Lib.inc


;determines the max number of mobs you will fight without mezzing any
;above this number, and the script will attempt to mez all but the assist's target
variable int numMobs = 1

;determines the gem slot where mez is memorized
variable int mezGemSlot = 1

;determines the length of time to wait before recasting mez on the same mob
variable int mezRecast = 45000

;stores last mez timing for each mezzed mob.
variable collection:int mezHistory

;processing binaries
variable int mezCast = 0
variable int mezResist = 0
variable int mezSuccess = 0


function AutoMez()
{  
	mezRecast:Set[${Math.Calc[${Me.Gem[${mezGemSlot}].Duration}*4800]}]
	echo ********************************************************************************
	echo Welcome to AutoMez, where you only ever have to fight ${numMobs} mobs at a time.
	echo If you want to fight more or less mobs than that, change numMobs in script.
	echo .
	echo If you haven't already, put your mez in gem slot ${mezGemSlot}, or update the mezGemSlot variable in script.
	echo Currently remezzing every ${Math.Calc[${mezRecast}/1000]} seconds, you can change this via the mezRecast variable.
	echo .
	echo Note: This script will attempt to mez all mobs except the one that the assist is targeting, whenever more than ${numMobs} are engaged.
	echo (ie if numMobs is set at 3 and there are 6 mobs attacking, this script will attempt to mez 5 mobs)
	echo . 
	echo user01 is the best!
	echo ********************************************************************************
	;continuous loop
	while 1 < 2
	{
		if ${Me.XTarget[]} > ${numMobs}
		{
			;echo Too many mobs, mezzing.
			variable int mezCounter
			mezCounter:Set[1]
			variable int mobs = 0
			mobs:Set[${Me.XTarget[]}]
			if ${mobs} > 1
			{
				while ${Me.XTarget[5].ID} == ${Me.XTarget[1].ID}
				{
					wait 1
				}
				mobs:Set[${Me.XTarget[]}]
			}
			if ${mobs} < 5
			{
				;take into account that assist target is in xtarget slot 5, so we'll only need to iterate through mobs-1.
				;if mobs is 5 or greater, we will iterate through all mobs, and just skip #5 
				mobs:Dec[1]
			}
			while ${mezCounter} <= ${mobs}
			{
				if ${mezCounter} == 5 
				{
					;skip assist target
					mezCounter:Inc[1]
					continue
				}
				if ${mezHistory.Element["${Me.XTarget[${mezCounter}].ID}"](exists)}
				{
					;mezzed this guy before, lets see how long ago it was
					if ${Math.Calc[${LavishScript.RunningTime}-${mezHistory.Element["${Me.XTarget[${mezCounter}].ID}"]}]} < ${mezRecast}
					{
						;havent waited long enough, skip to next mob
						mezCounter:Inc[1]
						continue
					}
				}
				OgreBotAPI:Set_Paused[TRUE]
				echo ${Time}: Mezzing XTarget[${mezCounter}]: ${Me.XTarget[${mezCounter}].Name}
				target ${Spawn[${Me.XTarget[${mezCounter}].ID}]}
				if ${Me.Class.Name.Equal[Bard]}	
				{
					;end current song
					eqexecute /melody
					wait 3
				}
				while !${Me.SpellReady[${mezGemSlot}]}
				{
					;in case character was already casting something from ogrebot, wait for it to finish
					wait 1
				}
				target ${Spawn[${Me.XTarget[${mezCounter}].ID}]}
				cast ${mezGemSlot}
				while ${Me.Casting(exists)}
				{
					;echo delaying while casting
					wait 2
					mezCast:Set[1]
					if ${Me.Class.Name.Equal[Bard]} && ${Math.Calc[${mezSuccess} + ${mezResist}]} > 0	
					{
						;bard would just keep on singing...
						eqexecute /melody
					}
				}
				if ${mezCast} == 1
				{
					;Waiting a few tenths of a second to give time for resist message (if applicable) to be processed
					wait 2
				}
				if ${mezSuccess} == 1
				{
					;Mez has been successful.
					mezHistory:Set["${Me.XTarget[${mezCounter}].ID}",${LavishScript.RunningTime}]
					echo ${Time}: Mez successful, taking note of when this mob was mezzed.
					if ${Me.XTarget[${mezCounter}](exists)}
					{
						eqexecute /g ${Me.XTarget[${mezCounter}].Name} has been mezzed.
					}
				}
				if ${mezSuccess} == 2
				{
					;target can not be mezzed.
					mezHistory:Set["${Me.XTarget[${mezCounter}].ID}",${Math.Calc[${LavishScript.RunningTime}+1000000]}]
					echo ${Time}: Mob not mezzable, will not try again for this ID.
					if ${Me.XTarget[${mezCounter}](exists)}
					{
						eqexecute /g ${Me.XTarget[${mezCounter}].Name} can not be mezzed.
					}
				}
				if ${mezResist} == 1
				{
					;Mez has been resisted.
					echo ${Time}: Mez resisted, will try again.
				}
				OgreBotAPI:Set_Paused[FALSE]
				while !${Me.SpellReady[${mezGemSlot}]}
				{
					;Wait for spell to be available before doing any more loops, but let ogre run while waiting
					;echo Waiting for spell to be ready
					wait 2
				}
				
				;Reset binaries, update counter
				mezCast:Set[0]
				mezSuccess:Set[0]
				mezResist:Set[0]
				mezCounter:Inc[1]
				
			}
		}
		if ${Me.XTarget[]} < ${numMobs}
		{
			if ${MezHistory.Size} > 10
			{
				;clear collection, no need to keep this info around.
				mezHistory:Clear
			}
		}
		wait 10
	}
}	



atom onIncomingText(string Text)
{
	;echo EQ2_onIncomingText - ${Text}
	
	;echo added class checks in case you have enchanter and bard in same group and both are mezzing.
	if ${Text.Find[Your target resisted](exists)}
	{
		if ${Me.Class.Name.Equal[Enchanter]}	
		{
			mezResist:Set[1]
		}
	}
	if ${Text.Find[ has been mesmerized](exists)}
	{
		if ${Me.Class.Name.Equal[Enchanter]}	
		{
			mezSuccess:Set[1]
		}
	}
	if ${Text.Find[ looking utterly befuddled](exists)}
	{
		if ${Me.Class.Name.Equal[Enchanter]}	
		{
			mezSuccess:Set[1]
		}
	}
	if ${Text.Find[ looking utterly baffled](exists)}
	{
		if ${Me.Class.Name.Equal[Enchanter]}	
		{
			mezSuccess:Set[1]
		}
	}
	if ${Text.Find[ gazes happily into space](exists)}
	{
		if ${Me.Class.Name.Equal[Enchanter]}	
		{
			mezSuccess:Set[1]
		}
	}
	if ${Text.Find[ falls asleep](exists)}
	{
		if ${Me.Class.Name.Equal[Enchanter]}	
		{
			mezSuccess:Set[1]
		}
	}
	if ${Text.Find[ jaw falls as they begin to drool](exists)}
	{
		if ${Me.Class.Name.Equal[Enchanter]}	
		{
			mezSuccess:Set[1]
		}
	}
	if ${Text.Find[ falls unconscious](exists)}
	{
		if ${Me.Class.Name.Equal[Bard]}	
		{
			mezSuccess:Set[1]
		}
	}
	if ${Text.Find[Your target cannot be](exists)}
	{
		mezSuccess:Set[2]
	}
}
 

function main()
{
	Event["EQ Chat"]:AttachAtom[onIncomingText]
    call AutoMez   
}